searchNodes=[{"doc":"Mix.Tasks.Upload.HotswapThis package provides a mix task named mix upload.hotswap to deploy local code changes to remote node(s) and to apply them without rebooting whole the application (the so-called hot code swapping).It could be convenient when you code for IoT devices backed by Nerves because it's much faster than mix firmware &amp;&amp; mix upload. Although you eventually need to update the firmware if you want to persist the changes onto devices, this task could be your help in development phase because it allows you to quickly confirm if your changes work fine on the devices without waiting long time.InstallationAdd mix_tasks_upload_hotswap to your list of dependencies in mix.exs:def deps do [ {:mix_tasks_upload_hotswap, &quot;~&gt; 0.1.0&quot;, only: :dev} ] endPrerequisitesTo use this package, you need to meet the requirements below:Add configurations for mix upload.hotswapStart node(s) on your device(s) through which your code changes are deployed1. Add configurations for mix upload.hotswapThe task mix upload.hotswap depends on the settings below are available:config :mix_tasks_upload_hotswap, app_name: :example, nodes: [:&quot;example@nerves.local&quot;], cookie: :&quot;secret token shared between nodes&quot;All the pairs above are required to be set.See example/config/config.exs for working example.2. Start node(s) on your device(s) through which your code changes are deployedStart a node which has the name and cookie set in the configuration above. The code should be like below:# Start a node through which local code changes are deployed # only when the device is running in the develop environment if Application.get_env(:example, :env) == :dev do System.cmd(&quot;epmd&quot;, [&quot;-daemon&quot;]) Node.start(:&quot;example@nerves.local&quot;) Node.set_cookie(Application.get_env(:mix_tasks_upload_hotswap, :cookie)) endNotice that the node starts only when the :env of the application is set to :dev. Below is an example to configure the environment value in config.exs:config :example, env: Mix.env()See example/lib/example/application.ex and example/config/config.exs for working example.UsageMix TaskMake some changes into your code and just execute the mix task as below:$ mix upload.hotswapIllustration by Example AppImagine there is an Example application which has hello method as below:def hello do :world endYou can confirm the method invoked on your device:$ ssh nerves.local (snip) iex(example@nerves.local)1&gt; Example.hello :worldSuppose you made some changes like below:diff --git a/example/lib/example.ex b/example/lib/example.ex index ca49896..81c696a 100644 --- a/example/lib/example.ex +++ b/example/lib/example.ex @@ -13,6 +13,6 @@ defmodule Example do &quot;&quot;&quot; def hello do - :world + :&quot;new world&quot; end endYou can deploy the changes to the device as below:$ mix upload.hotswap ==&gt; nerves ==&gt; example Nerves environment MIX_TARGET: rpi3 MIX_ENV: dev Compiling 2 files (.ex) Generated example app Successfully connected to example@nerves.local Successfully deployed Elixir.Example to example@nerves.local Successfully deployed Elixir.Example.Application to example@nerves.localNow you can see the changes applied into the code on the device:$ ssh nerves.local (snip) iex(example@nerves.local)1&gt; Example.hello :&quot;new world&quot;It's much faster than mix firmware &amp;&amp; mix upload.AcknowledgementUsing Erlang Distribution to test hardware - Embedded Elixir inspired me how to implement this package.AuthorKentaro KuribayashiLicenseMIT","ref":"Mix.Tasks.Upload.Hotswap.html","title":"Mix.Tasks.Upload.Hotswap","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Upload.Hotswap.html#run/1","title":"Mix.Tasks.Upload.Hotswap.run/1","type":"function"}]